diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/wifi-spectrum-value-helper.cc ns-3.44/src/wifi/model/wifi-spectrum-value-helper.cc
--- ns-3.43/src/wifi/model/wifi-spectrum-value-helper.cc	2024-10-09 16:41:10.132656800 -0700
+++ ns-3.44/src/wifi/model/wifi-spectrum-value-helper.cc	2025-03-09 16:55:49.803372600 -0700
@@ -58,9 +58,9 @@
 
 /**
  * Less than operator
- * \param lhs the left hand side wifi spectrum to compare
- * \param rhs the right hand side wifi spectrum to compare
- * \returns true if the left hand side spectrum is less than the right hand side spectrum
+ * @param lhs the left hand side wifi spectrum to compare
+ * @param rhs the right hand side wifi spectrum to compare
+ * @returns true if the left hand side spectrum is less than the right hand side spectrum
  */
 bool
 operator<(const WifiSpectrumModelId& lhs, const WifiSpectrumModelId& rhs)
@@ -110,10 +110,10 @@
             std::minmax_element(centerFrequencies.cbegin(), centerFrequencies.cend());
         const auto separationWidth =
             (minCenterFrequency == maxCenterFrequency)
-                ? 0
+                ? MHz_u{0}
                 : (*maxCenterFrequency - *minCenterFrequency - (channelWidth / 2));
-        NS_ASSERT(separationWidth == 0 || centerFrequencies.size() == 2);
-        Hz_u bandwidth = (channelWidth + (2 * guardBandwidth) + separationWidth) * 1e6;
+        NS_ASSERT(separationWidth == MHz_u{0} || centerFrequencies.size() == 2);
+        const auto bandwidth = MHzToHz((channelWidth + (2 * guardBandwidth) + separationWidth));
         // For OFDM, the center subcarrier is null (at center frequency)
         uint32_t numBands = std::ceil(bandwidth / carrierSpacing);
         NS_ASSERT(numBands > 0);
@@ -132,13 +132,13 @@
         // total width, only a quarter of the channel width has to be subtracted. Finally, we
         // remove the guard band width to get the center frequency of the first band and half the
         // carrier spacing to get the effective starting frequency of the first band.
-        const auto startingFrequencyHz = *minCenterFrequency * 1e6 -
-                                         ((channelWidth * 1e6) / (2 * centerFrequencies.size())) -
-                                         (guardBandwidth * 1e6) - (carrierSpacing / 2);
+        const auto startingFrequency = MHzToHz(*minCenterFrequency) -
+                                       (MHzToHz(channelWidth) / (2 * centerFrequencies.size())) -
+                                       MHzToHz(guardBandwidth) - (carrierSpacing / 2);
         for (size_t i = 0; i < numBands; i++)
         {
             BandInfo info;
-            auto f = startingFrequencyHz + (i * carrierSpacing);
+            auto f = startingFrequency + (i * carrierSpacing);
             info.fl = f;
             f += carrierSpacing / 2;
             info.fc = f;
@@ -162,14 +162,15 @@
                                                           MHz_u guardBandwidth)
 {
     NS_LOG_FUNCTION(centerFrequency << txPower << +guardBandwidth);
-    MHz_u channelWidth = 22; // DSSS channels are 22 MHz wide
-    Hz_u carrierSpacing = 312500;
+    MHz_u channelWidth{22}; // DSSS channels are 22 MHz wide
+    Hz_u carrierSpacing{312500};
     Ptr<SpectrumValue> c = Create<SpectrumValue>(
         GetSpectrumModel({centerFrequency}, channelWidth, carrierSpacing, guardBandwidth));
     auto vit = c->ValuesBegin();
     auto bit = c->ConstBandsBegin();
-    auto nGuardBands = static_cast<uint32_t>(((2 * guardBandwidth * 1e6) / carrierSpacing) + 0.5);
-    auto nAllocatedBands = static_cast<uint32_t>(((channelWidth * 1e6) / carrierSpacing) + 0.5);
+    auto nGuardBands =
+        static_cast<uint32_t>(((MHzToHz(2 * guardBandwidth)) / carrierSpacing) + 0.5);
+    auto nAllocatedBands = static_cast<uint32_t>((MHzToHz(channelWidth) / carrierSpacing) + 0.5);
     NS_ASSERT(c->GetSpectrumModel()->GetNumBands() == (nAllocatedBands + nGuardBands + 1));
     // Evenly spread power across 22 MHz
     const auto txPowerPerBand = txPower / nAllocatedBands;
@@ -195,23 +196,24 @@
 {
     NS_LOG_FUNCTION(centerFrequency << channelWidth << txPower << guardBandwidth << minInnerBand
                                     << minOuterBand << lowestPoint);
-    Hz_u carrierSpacing = 0;
+    Hz_u carrierSpacing{0};
     uint32_t innerSlopeWidth = 0;
     switch (static_cast<uint16_t>(channelWidth))
     {
     case 20:
-        carrierSpacing = 312500;                                               // Hz
-        innerSlopeWidth = static_cast<uint32_t>((2e6 / carrierSpacing) + 0.5); // [-11;-9] & [9;11]
+        carrierSpacing = Hz_u{312500};
+        innerSlopeWidth =
+            static_cast<uint32_t>((Hz_u{2e6} / carrierSpacing) + 0.5); // [-11;-9] & [9;11]
         break;
     case 10:
-        carrierSpacing = 156250; // Hz
+        carrierSpacing = Hz_u{156250};
         innerSlopeWidth =
-            static_cast<uint32_t>((1e6 / carrierSpacing) + 0.5); // [-5.5;-4.5] & [4.5;5.5]
+            static_cast<uint32_t>((Hz_u{1e6} / carrierSpacing) + 0.5); // [-5.5;-4.5] & [4.5;5.5]
         break;
     case 5:
-        carrierSpacing = 78125; // Hz
+        carrierSpacing = Hz_u{78125};
         innerSlopeWidth =
-            static_cast<uint32_t>((5e5 / carrierSpacing) + 0.5); // [-2.75;-2.5] & [2.5;2.75]
+            static_cast<uint32_t>((Hz_u{5e5} / carrierSpacing) + 0.5); // [-2.75;-2.5] & [2.5;2.75]
         break;
     default:
         NS_FATAL_ERROR("Channel width " << channelWidth << " should be correctly set.");
@@ -220,8 +222,9 @@
 
     auto c = Create<SpectrumValue>(
         GetSpectrumModel({centerFrequency}, channelWidth, carrierSpacing, guardBandwidth));
-    auto nGuardBands = static_cast<uint32_t>(((2 * guardBandwidth * 1e6) / carrierSpacing) + 0.5);
-    auto nAllocatedBands = static_cast<uint32_t>(((channelWidth * 1e6) / carrierSpacing) + 0.5);
+    auto nGuardBands =
+        static_cast<uint32_t>(((MHzToHz(2 * guardBandwidth)) / carrierSpacing) + 0.5);
+    auto nAllocatedBands = static_cast<uint32_t>((MHzToHz(channelWidth) / carrierSpacing) + 0.5);
     NS_ASSERT_MSG(c->GetSpectrumModel()->GetNumBands() == (nAllocatedBands + nGuardBands + 1),
                   "Unexpected number of bands " << c->GetSpectrumModel()->GetNumBands());
     // 52 subcarriers (48 data + 4 pilot)
@@ -267,36 +270,37 @@
     const std::vector<bool>& puncturedSubchannels)
 {
     NS_ASSERT_MSG(centerFrequencies.size() == 1 ||
-                      (channelWidth == 160 && centerFrequencies.size() <= 2),
+                      (channelWidth == MHz_u{160} && centerFrequencies.size() <= 2),
                   "PSD for non-contiguous channels is only possible when the total width is 160 "
                   "MHz and cannot be made of more than 2 segments");
     NS_LOG_FUNCTION(printFrequencies(centerFrequencies)
                     << channelWidth << txPower << guardBandwidth << minInnerBand << minOuterBand
                     << lowestPoint);
-    const Hz_u carrierSpacing = 312500;
+    const Hz_u carrierSpacing{312500};
     Ptr<SpectrumValue> c = Create<SpectrumValue>(
         GetSpectrumModel(centerFrequencies, channelWidth, carrierSpacing, guardBandwidth));
     // assume all frequency segments have the same width, hence split the guard bandwidth
     // accordingly over the segments
     guardBandwidth /= centerFrequencies.size();
     const auto nGuardBands =
-        static_cast<uint32_t>(((2 * guardBandwidth * 1e6) / carrierSpacing) + 0.5);
+        static_cast<uint32_t>(((MHzToHz(2 * guardBandwidth)) / carrierSpacing) + 0.5);
     const auto nAllocatedBands =
-        static_cast<uint32_t>(((channelWidth * 1e6) / carrierSpacing) + 0.5);
+        static_cast<uint32_t>((MHzToHz(channelWidth) / carrierSpacing) + 0.5);
     const auto separationWidth = std::abs(centerFrequencies.back() - centerFrequencies.front());
-    const auto unallocatedWidth = separationWidth > 0 ? (separationWidth - (channelWidth / 2)) : 0;
+    const auto unallocatedWidth =
+        separationWidth > Hz_u{0} ? (separationWidth - (channelWidth / 2)) : 0;
     const auto nUnallocatedBands =
-        static_cast<uint32_t>(((unallocatedWidth * 1e6) / carrierSpacing) + 0.5);
+        static_cast<uint32_t>((MHzToHz(unallocatedWidth) / carrierSpacing) + 0.5);
     NS_ASSERT_MSG(c->GetSpectrumModel()->GetNumBands() ==
                       (nAllocatedBands + nGuardBands + nUnallocatedBands + 1),
                   "Unexpected number of bands " << c->GetSpectrumModel()->GetNumBands());
-    std::size_t num20MhzBands = channelWidth / 20;
+    auto num20MhzBands = Count20MHzSubchannels(channelWidth);
     std::size_t numAllocatedSubcarriersPer20MHz = 52;
     NS_ASSERT(puncturedSubchannels.empty() || (puncturedSubchannels.size() == num20MhzBands));
     const auto txPowerPerBand = (txPower / numAllocatedSubcarriersPer20MHz) / num20MhzBands;
     NS_LOG_DEBUG("Power per band " << txPowerPerBand << "W");
 
-    std::size_t numSubcarriersPer20MHz = (20 * 1e6) / carrierSpacing;
+    std::size_t numSubcarriersPer20MHz = MHzToHz(MHz_u{20}) / carrierSpacing;
     std::size_t numUnallocatedSubcarriersPer20MHz =
         numSubcarriersPer20MHz - numAllocatedSubcarriersPer20MHz;
     std::vector<std::vector<WifiSpectrumBandIndices>> subBandsPerSegment(
@@ -336,11 +340,11 @@
 
     // Prepare spectrum mask specific variables
     auto innerSlopeWidth = static_cast<uint32_t>(
-        (2e6 / carrierSpacing) +
+        (Hz_u{2e6} / carrierSpacing) +
         0.5); // size in number of subcarriers of the 0dBr<->20dBr slope (2MHz for HT/VHT)
     WifiSpectrumBandIndices maskBand(0, nAllocatedBands + nGuardBands + nUnallocatedBands);
     const auto puncturedSlopeWidth =
-        static_cast<uint32_t>((500e3 / carrierSpacing) +
+        static_cast<uint32_t>((Hz_u{500e3} / carrierSpacing) +
                               0.5); // size in number of subcarriers of the punctured slope band
 
     // Build transmit spectrum mask
@@ -371,35 +375,36 @@
     dBr_u lowestPoint)
 {
     NS_ASSERT_MSG(centerFrequencies.size() == 1 ||
-                      (channelWidth == 160 && centerFrequencies.size() <= 2),
+                      (channelWidth == MHz_u{160} && centerFrequencies.size() <= 2),
                   "PSD for non-contiguous channels is only possible when the total width is 160 "
                   "MHz and cannot be made of more than 2 segments");
     NS_LOG_FUNCTION(printFrequencies(centerFrequencies)
                     << channelWidth << txPower << guardBandwidth << minInnerBand << minOuterBand
                     << lowestPoint);
-    const Hz_u carrierSpacing = 312500;
+    const Hz_u carrierSpacing{312500};
     Ptr<SpectrumValue> c = Create<SpectrumValue>(
         GetSpectrumModel(centerFrequencies, channelWidth, carrierSpacing, guardBandwidth));
     // assume all frequency segments have the same width, hence split the guard bandwidth
     // accordingly over the segments
     guardBandwidth /= centerFrequencies.size();
     const auto nGuardBands =
-        static_cast<uint32_t>(((2 * guardBandwidth * 1e6) / carrierSpacing) + 0.5);
+        static_cast<uint32_t>(((MHzToHz(2 * guardBandwidth)) / carrierSpacing) + 0.5);
     const auto nAllocatedBands =
-        static_cast<uint32_t>(((channelWidth * 1e6) / carrierSpacing) + 0.5);
+        static_cast<uint32_t>((MHzToHz(channelWidth) / carrierSpacing) + 0.5);
     const auto separationWidth = std::abs(centerFrequencies.back() - centerFrequencies.front());
-    const auto unallocatedWidth = separationWidth > 0 ? (separationWidth - (channelWidth / 2)) : 0;
+    const auto unallocatedWidth =
+        separationWidth > Hz_u{0} ? (separationWidth - (channelWidth / 2)) : 0;
     const auto nUnallocatedBands =
-        static_cast<uint32_t>(((unallocatedWidth * 1e6) / carrierSpacing) + 0.5);
+        static_cast<uint32_t>((MHzToHz(unallocatedWidth) / carrierSpacing) + 0.5);
     NS_ASSERT_MSG(c->GetSpectrumModel()->GetNumBands() ==
                       (nAllocatedBands + nGuardBands + nUnallocatedBands + 1),
                   "Unexpected number of bands " << c->GetSpectrumModel()->GetNumBands());
-    std::size_t num20MhzBands = channelWidth / 20;
+    auto num20MhzBands = Count20MHzSubchannels(channelWidth);
     std::size_t numAllocatedSubcarriersPer20MHz = 56;
     const auto txPowerPerBand = (txPower / numAllocatedSubcarriersPer20MHz) / num20MhzBands;
     NS_LOG_DEBUG("Power per band " << txPowerPerBand << "W");
 
-    std::size_t numSubcarriersPer20MHz = (20 * 1e6) / carrierSpacing;
+    std::size_t numSubcarriersPer20MHz = MHzToHz(MHz_u{20}) / carrierSpacing;
     std::size_t numUnallocatedSubcarriersPer20MHz =
         numSubcarriersPer20MHz - numAllocatedSubcarriersPer20MHz;
     std::vector<std::vector<WifiSpectrumBandIndices>> subBandsPerSegment(
@@ -430,7 +435,7 @@
 
     // Prepare spectrum mask specific variables
     auto innerSlopeWidth = static_cast<uint32_t>(
-        (2e6 / carrierSpacing) +
+        (Hz_u{2e6} / carrierSpacing) +
         0.5); // size in number of subcarriers of the inner band (2MHz for HT/VHT)
     WifiSpectrumBandIndices maskBand(0, nAllocatedBands + nGuardBands + nUnallocatedBands);
 
@@ -482,29 +487,30 @@
     const std::vector<bool>& puncturedSubchannels)
 {
     NS_ASSERT_MSG(
-        centerFrequencies.size() == 1 || channelWidth == 160,
+        centerFrequencies.size() == 1 || channelWidth == MHz_u{160},
         "PSD for non-contiguous channels is only possible when the total width is 160 MHz");
     NS_LOG_FUNCTION(printFrequencies(centerFrequencies)
                     << channelWidth << txPower << guardBandwidth << minInnerBand << minOuterBand
                     << lowestPoint);
-    const Hz_u carrierSpacing = 78125;
+    const Hz_u carrierSpacing{78125};
     Ptr<SpectrumValue> c = Create<SpectrumValue>(
         GetSpectrumModel(centerFrequencies, channelWidth, carrierSpacing, guardBandwidth));
     // assume all frequency segments have the same width, hence split the guard bandwidth
     // accordingly over the segments
     guardBandwidth /= centerFrequencies.size();
     const auto nGuardBands =
-        static_cast<uint32_t>(((2 * guardBandwidth * 1e6) / carrierSpacing) + 0.5);
+        static_cast<uint32_t>(((MHzToHz(2 * guardBandwidth)) / carrierSpacing) + 0.5);
     const auto separationWidth = std::abs(centerFrequencies.back() - centerFrequencies.front());
-    const auto unallocatedWidth = separationWidth > 0 ? (separationWidth - (channelWidth / 2)) : 0;
+    const auto unallocatedWidth =
+        separationWidth > Hz_u{0} ? (separationWidth - (channelWidth / 2)) : 0;
     const auto nUnallocatedBands =
-        static_cast<uint32_t>(((unallocatedWidth * 1e6) / carrierSpacing) + 0.5);
+        static_cast<uint32_t>((MHzToHz(unallocatedWidth) / carrierSpacing) + 0.5);
     const auto nAllocatedBands =
-        static_cast<uint32_t>(((channelWidth * 1e6) / carrierSpacing) + 0.5);
+        static_cast<uint32_t>((MHzToHz(channelWidth) / carrierSpacing) + 0.5);
     NS_ASSERT_MSG(c->GetSpectrumModel()->GetNumBands() ==
                       (nAllocatedBands + nGuardBands + nUnallocatedBands + 1),
                   "Unexpected number of bands " << c->GetSpectrumModel()->GetNumBands());
-    Watt_u txPowerPerBand = 0.0;
+    Watt_u txPowerPerBand{0.0};
     uint32_t start1;
     uint32_t stop1;
     uint32_t start2;
@@ -514,8 +520,9 @@
     uint32_t start4;
     uint32_t stop4;
     // Prepare spectrum mask specific variables
-    auto innerSlopeWidth = static_cast<uint32_t>(
-        (1e6 / carrierSpacing) + 0.5); // size in number of subcarriers of the inner band
+    auto innerSlopeWidth =
+        static_cast<uint32_t>((MHzToHz(MHz_u{1}) / carrierSpacing) +
+                              0.5); // size in number of subcarriers of the inner band
     std::vector<std::vector<WifiSpectrumBandIndices>> subBandsPerSegment(
         centerFrequencies.size()); // list of data/pilot-containing subBands (sent at 0dBr)
     WifiSpectrumBandIndices maskBand(0, nAllocatedBands + nGuardBands + nUnallocatedBands);
@@ -524,8 +531,8 @@
     case 20:
         // 242 subcarriers (234 data + 8 pilot)
         txPowerPerBand = txPower / 242;
-        innerSlopeWidth =
-            static_cast<uint32_t>((5e5 / carrierSpacing) + 0.5); // [-10.25;-9.75] & [9.75;10.25]
+        innerSlopeWidth = static_cast<uint32_t>((Hz_u{5e5} / carrierSpacing) +
+                                                0.5); // [-10.25;-9.75] & [9.75;10.25]
         // skip the guard band and 6 subbands, then place power in 121 subbands, then
         // skip 3 DC, then place power in 121 subbands, then skip
         // the final 5 subbands and the guard band.
@@ -589,10 +596,10 @@
 
     // Create punctured bands
     auto puncturedSlopeWidth =
-        static_cast<uint32_t>((500e3 / carrierSpacing) +
+        static_cast<uint32_t>((Hz_u{500e3} / carrierSpacing) +
                               0.5); // size in number of subcarriers of the punctured slope band
     std::vector<std::vector<WifiSpectrumBandIndices>> puncturedBandsPerSegment;
-    std::size_t subcarriersPerSuband = (20 * 1e6 / carrierSpacing);
+    std::size_t subcarriersPerSuband = (MHzToHz(MHz_u{20}) / carrierSpacing);
     uint32_t start = (nGuardBands / 2);
     uint32_t stop = start + subcarriersPerSuband - 1;
     if (!puncturedSubchannels.empty())
@@ -657,7 +664,7 @@
     };
     NS_LOG_FUNCTION(printFrequencies(centerFrequencies)
                     << channelWidth << txPower << guardBandwidth << printRuIndices(ru));
-    const Hz_u carrierSpacing = 78125;
+    const Hz_u carrierSpacing{78125};
     Ptr<SpectrumValue> c = Create<SpectrumValue>(
         GetSpectrumModel(centerFrequencies, channelWidth, carrierSpacing, guardBandwidth));
 
@@ -711,11 +718,11 @@
     NS_LOG_LOGIC("Power per band " << txPowerPerBand << "W");
 
     // Different power levels
-    dBm_u txPowerRef = (10.0 * std::log10(txPowerPerBand * 1000.0));
-    dBm_u txPowerInnerBandMin = txPowerRef + minInnerBand;
-    dBm_u txPowerMiddleBandMin = txPowerRef + minOuterBand;
-    dBm_u txPowerOuterBandMin =
-        txPowerRef + lowestPoint; // TODO also take into account dBm/MHz constraints
+    dBm_u txPowerRef{10.0 * std::log10(txPowerPerBand * 1000.0)};
+    dBm_u txPowerInnerBandMin{txPowerRef + minInnerBand};
+    dBm_u txPowerMiddleBandMin{txPowerRef + minOuterBand};
+    dBm_u txPowerOuterBandMin{txPowerRef +
+                              lowestPoint}; // TODO also take into account dBm/MHz constraints
 
     // Different widths (in number of bands)
     uint32_t outerSlopeWidth =
@@ -876,23 +883,23 @@
     double puncturedSlope = (-1.0 * minInnerBand) / puncturedSlopeWidth;
 
     // Build spectrum mask
-    Watt_u previousTxPower = 0.0;
+    Watt_u previousTxPower{0.0};
     std::vector<Watt_u> txPowerValues(numBands);
     NS_ASSERT(txPowerValues.size() == numBands);
     for (size_t i = 0; i < numBands; ++i)
     {
         size_t psdIndex =
             (allocatedSubBandsPerSegment.size() == 1) ? 0 : ((i < (numBands / 2)) ? 0 : 1);
-        Watt_u txPower = 0.0;
+        Watt_u txPower{0.0};
         if (i < maskBand.first || i > maskBand.second) // outside the spectrum mask
         {
-            txPower = 0.0;
+            txPower = Watt_u{0.0};
         }
         else if (betweenPsdsBand.has_value() &&
                  (i <= betweenPsdsBand->second && i >= betweenPsdsBand->first))
         {
             // value for PSD mask 1
-            std::vector<double> txPowerWPsds(2);
+            std::vector<Watt_u> txPowerWPsds(2);
             if (i <= middleBandsRight.at(0).second && i >= middleBandsRight.at(0).first)
             {
                 txPowerWPsds.at(0) =
@@ -936,7 +943,7 @@
                 NS_ASSERT(false);
             }
 
-            txPower = std::accumulate(txPowerWPsds.cbegin(), txPowerWPsds.cend(), 0.0);
+            txPower = std::accumulate(txPowerWPsds.cbegin(), txPowerWPsds.cend(), Watt_u{0.0});
             txPower = std::max(DbmToW(txPowerRef - 25.0), txPower);
             txPower = std::min(DbmToW(txPowerRef - 20.0), txPower);
         }
@@ -1082,7 +1089,7 @@
 {
     NS_LOG_FUNCTION(c << txPower);
     // Normalize power so that total signal power equals transmit power
-    Watt_u currentTxPower = Integral(*c);
+    Watt_u currentTxPower{Integral(*c)};
     double normalizationRatio [[maybe_unused]] = currentTxPower / txPower;
     double invNormalizationRatio = txPower / currentTxPower;
     NS_LOG_LOGIC("Current power: " << currentTxPower << "W vs expected power: " << txPower << "W"
@@ -1117,7 +1124,7 @@
             ++index;
         }
     }
-    const Watt_u power = powerWattPerHertz * bandWidth;
+    const Watt_u power{powerWattPerHertz * bandWidth};
     NS_ASSERT_MSG(power >= 0.0, "Invalid calculated power " << power);
     return power;
 }
